### Eclipse Workspace Patch 1.0
#P org.jboss.tools.ws.ui
Index: META-INF/MANIFEST.MF
===================================================================
--- META-INF/MANIFEST.MF	(revision 25432)
+++ META-INF/MANIFEST.MF	(working copy)
@@ -23,20 +23,17 @@
  org.eclipse.wst.server.core,
  org.eclipse.core.filesystem,
  com.ibm.icu,
- org.apache.axis,
- javax.xml.rpc,
  org.eclipse.wst.internet.monitor.core,
  org.eclipse.wst.internet.monitor.ui,
  javax.wsdl;bundle-version="1.6.2",
  org.jdom,
- javax.xml.ws,
  org.eclipse.ui.forms,
  org.eclipse.emf.common,
  org.eclipse.jdt.ui,
  org.eclipse.osgi,
  org.eclipse.jst.ws.annotations.core,
  org.apache.commons.codec,
- javax.xml.soap;bundle-version="[1.2.0,1.3.0)"
+ org.apache.commons.discovery;bundle-version="[0.2.0,1.0.0)"
 Bundle-ActivationPolicy: lazy
 Export-Package: javax.ws.rs,
  javax.ws.rs.core,
@@ -50,9 +47,17 @@
 Bundle-Vendor: %PLUGIN_PROVIDER
 Eclipse-RegisterBuddy: org.eclipse.jst.ws.annotations.core
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
-Import-Package: javax.xml.ws,
+Import-Package: javax.activation,
+ javax.mail,
+ javax.mail.internet,
+ javax.servlet;version="[2.4.0,3.0.0)",
+ javax.servlet.http;version="[2.4.0,3.0.0)",
+ org.apache.commons.logging;version="[1.0.4,2.0.0)",
+ org.apache.commons.logging.impl;version="[1.0.4,2.0.0)",
  org.eclipse.jst.javaee.web,
  org.jboss.tools.ws.creation.core.commands,
  org.jboss.tools.ws.creation.core.data
-Bundle-ClassPath: lib/jaxrs-api.jar,
- .
+Bundle-ClassPath: .,
+ lib/jaxrs-api.jar,
+ lib/axis.jar,
+ lib/jaxrpc.jar
Index: src/log4j.properties
===================================================================
--- src/log4j.properties	(revision 0)
+++ src/log4j.properties	(revision 0)
@@ -0,0 +1,20 @@
+# Set root category priority to INFO and its only appender to CONSOLE.
+log4j.rootCategory=INFO, CONSOLE
+#log4j.rootCategory=INFO, CONSOLE, LOGFILE
+
+# Set the enterprise logger category to FATAL and its only appender to CONSOLE.
+log4j.logger.org.apache.axis.enterprise=FATAL, CONSOLE
+
+# CONSOLE is set to be a ConsoleAppender using a PatternLayout.
+log4j.appender.CONSOLE=org.apache.log4j.ConsoleAppender
+log4j.appender.CONSOLE.Threshold=INFO
+log4j.appender.CONSOLE.layout=org.apache.log4j.PatternLayout
+log4j.appender.CONSOLE.layout.ConversionPattern=- %m%n
+
+# LOGFILE is set to be a File appender using a PatternLayout.
+log4j.appender.LOGFILE=org.apache.log4j.FileAppender
+log4j.appender.LOGFILE.File=axis.log
+log4j.appender.LOGFILE.Append=true
+log4j.appender.LOGFILE.Threshold=INFO
+log4j.appender.LOGFILE.layout=org.apache.log4j.PatternLayout
+log4j.appender.LOGFILE.layout.ConversionPattern=%-4r [%t] %-5p %c %x - %m%n
Index: lib/axis.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib\axis.jar
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: lib/jaxrpc.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: lib\jaxrpc.jar
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: .classpath
===================================================================
--- .classpath	(revision 26547)
+++ .classpath	(working copy)
@@ -1,8 +1,10 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<classpath>
-	<classpathentry exported="true" kind="lib" path="lib/jaxrs-api.jar"/>
-	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.6"/>
-	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
-	<classpathentry kind="src" path="src"/>
-	<classpathentry kind="output" path="bin"/>
-</classpath>
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry exported="true" kind="lib" path="lib/axis.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/jaxrpc.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/jaxrs-api.jar"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.6"/>
+	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
Index: build.properties
===================================================================
--- build.properties	(revision 25432)
+++ build.properties	(working copy)
@@ -10,5 +10,6 @@
                about.properties,\
                icons/,\
                jboss_about.png,\
-               lib/jaxrs-api.jar
+               lib/,\
+               plugin_ja.properties
 additional.bundles = javax.xml.bind