Index: pom.xml
===================================================================
--- pom.xml	(revision 2553)
+++ pom.xml	(working copy)
@@ -132,23 +132,43 @@
 
 	<build>
 		<outputDirectory>target/classes</outputDirectory>
+		<plugins>
+			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-dependency-plugin</artifactId>
+				<executions>
+					<execution>
+						<id>copy</id>
+						<phase>clean</phase>
+						<goals>
+							<goal>copy</goal>
+						</goals>
+						<configuration>
+							<artifactItems>
+								<artifactItem>
+									<groupId>org.modeshape</groupId>
+									<artifactId>modeshape-jbossas-service</artifactId>
+									<version>${project.version}</version>
+									<type>jar</type>
+									<overWrite>true</overWrite>
+								</artifactItem>
+							</artifactItems>
+							<outputDirectory>src/main/resources/lib</outputDirectory>
+						</configuration>
+					</execution>
+				</executions>
+			</plugin>
+		</plugins>
 		<resources>
 			<resource>
 				<directory>src/main/resources</directory>
-				<filtering>true</filtering>
+				<filtering>false</filtering>
 				<includes>
 					<include>**/*.xml</include>
 					<include>**/*.properties</include>
+					<include>**/modeshape*.jar</include>
 				</includes>
 			</resource>
-			<resource>
-				<directory>src/main/resources</directory>
-				<filtering>false</filtering>
-				<excludes>
-					<exclude>**/*.xml</exclude>
-					<exclude>**/*.properties</exclude>
-				</excludes>
-			</resource>
 		</resources>
 	</build>
 
Index: .classpath
===================================================================
--- .classpath	(revision 2553)
+++ .classpath	(working copy)
@@ -2,6 +2,8 @@
 <classpath>
 	<classpathentry kind="src" output="target/classes" path="src/main/java"/>
 	<classpathentry excluding="**" kind="src" output="target/classes" path="src/main/resources"/>
+	<classpathentry kind="src" output="target/test-classes" path="src/test/java"/>
+	<classpathentry excluding="**" kind="src" output="target/test-classes" path="src/test/resources"/>
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.6"/>
 	<classpathentry kind="con" path="org.maven.ide.eclipse.MAVEN2_CLASSPATH_CONTAINER"/>
 	<classpathentry kind="output" path="target/classes"/>
Index: src/main/java/org/modeshape/rhq/plugin/RepositoryDiscoveryComponent.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/RepositoryDiscoveryComponent.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/RepositoryDiscoveryComponent.java	(working copy)
@@ -34,8 +34,7 @@
 import org.jboss.metatype.api.values.CollectionValueSupport;
 import org.jboss.metatype.api.values.CompositeValueSupport;
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
-import org.modeshape.jboss.managed.ManagedEngine;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.modeshape.jboss.managed.ManagedRepository;
 import org.modeshape.rhq.plugin.util.ModeShapeManagementView;
 import org.modeshape.rhq.plugin.util.PluginConstants;
@@ -88,15 +87,15 @@
 			return discoveredResources;
 		}
 
-		Collection<ManagedRepository> repositoryCollection = ModeShapeManagementView
+		Collection<MetaValue> repositoryCollection = ModeShapeManagementView
 				.getRepositoryCollectionValue(repositories);
 
-		for (ManagedRepository managedRepository : repositoryCollection) {
+		for (MetaValue managedRepository : repositoryCollection) {
 
-			String name = managedRepository.getName();
+			MetaValue name = ((CompositeValueSupport)managedRepository).get("name");
 			MetaValue version = ModeShapeManagementView
 					.executeManagedOperation(mc, "getRepositoryVersion",
-							MetaValueFactory.getInstance().create(name));
+							name);
 
 			/**
 			 * 
@@ -105,8 +104,8 @@
 			 */
 			DiscoveredResourceDetails detail = new DiscoveredResourceDetails(
 					discoveryContext.getResourceType(), // ResourceType
-					name, // Resource Key
-					name, // Resource name
+					ProfileServiceUtil.stringValue(name), // Resource Key
+					ProfileServiceUtil.stringValue(name), // Resource name
 					ProfileServiceUtil.stringValue(version), // Version
 					PluginConstants.ComponentType.Repository.MODESHAPE_REPOSITORY_DESC, // Description
 					discoveryContext.getDefaultPluginConfiguration(), // Plugin config
@@ -118,7 +117,7 @@
 			operation = "getRepositoryProperties";
 
 			MetaValue[] args = new MetaValue[] {
-					MetaValueFactory.getInstance().create(name)};
+					name};
 			
 			MetaValue properties = ModeShapeManagementView
 					.executeManagedOperation(mc, operation, args);
Index: src/main/java/org/modeshape/rhq/plugin/ConnectorDiscoveryComponent.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/ConnectorDiscoveryComponent.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/ConnectorDiscoveryComponent.java	(working copy)
@@ -29,10 +29,12 @@
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.jboss.managed.api.ManagedComponent;
+import org.jboss.metatype.api.types.EnumMetaType;
 import org.jboss.metatype.api.values.CollectionValueSupport;
 import org.jboss.metatype.api.values.CompositeValueSupport;
+import org.jboss.metatype.api.values.EnumValueSupport;
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.modeshape.jboss.managed.ManagedEngine;
 import org.modeshape.rhq.plugin.util.ModeShapeManagementView;
 import org.modeshape.rhq.plugin.util.PluginConstants;
@@ -109,11 +111,12 @@
 
 			//Load connector properties
 			operation = "getProperties";
-
+			
+			EnumValueSupport enumVs = new EnumValueSupport(new EnumMetaType(ManagedEngine.Component.values()), ManagedEngine.Component.CONNECTOR);
+			
 			MetaValue[] args = new MetaValue[] {
-					MetaValueFactory.getInstance().create(name),
-					MetaValueFactory.getInstance().create(
-							ManagedEngine.Component.CONNECTOR) };
+					SimpleValueSupport.wrap(name),
+					enumVs};
 
 			MetaValue properties = ModeShapeManagementView
 					.executeManagedOperation(mc, operation, args);
@@ -126,10 +129,11 @@
 			loadProperties(propertyArray, connectorlist);
 
 			//Load connection pool properties
+			enumVs = new EnumValueSupport(new EnumMetaType(ManagedEngine.Component.values()), ManagedEngine.Component.CONNECTIONPOOL);
+			
 			args = new MetaValue[] {
-					MetaValueFactory.getInstance().create(name),
-					MetaValueFactory.getInstance().create(
-							ManagedEngine.Component.CONNECTIONPOOL) };
+					SimpleValueSupport.wrap(name),
+					enumVs };
 
 			properties = ModeShapeManagementView
 					.executeManagedOperation(mc, operation, args);
Index: src/main/java/org/modeshape/rhq/plugin/SequencingServiceDiscoveryComponent.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/SequencingServiceDiscoveryComponent.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/SequencingServiceDiscoveryComponent.java	(working copy)
@@ -30,10 +30,13 @@
 import org.apache.commons.logging.LogFactory;
 import org.jboss.managed.api.ComponentType;
 import org.jboss.managed.api.ManagedComponent;
+import org.jboss.metatype.api.types.EnumMetaType;
 import org.jboss.metatype.api.values.CollectionValueSupport;
 import org.jboss.metatype.api.values.CompositeValueSupport;
+import org.jboss.metatype.api.values.EnumValueSupport;
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
+import org.jboss.metatype.api.values.SimpleValue;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.modeshape.jboss.managed.ManagedEngine;
 import org.modeshape.rhq.plugin.util.ModeShapeManagementView;
 import org.modeshape.rhq.plugin.util.PluginConstants;
@@ -98,10 +101,10 @@
 		//Load properties
 		String operation = "getProperties";
 
+		EnumValueSupport enumVs = new EnumValueSupport(new EnumMetaType(ManagedEngine.Component.values()), ManagedEngine.Component.SEQUENCINGSERVICE);
 		MetaValue[] args = new MetaValue[] {
 				null,
-				MetaValueFactory.getInstance().create(
-						ManagedEngine.Component.SEQUENCINGSERVICE) };
+				enumVs };
 
 		MetaValue properties = ModeShapeManagementView
 				.executeManagedOperation(mc, operation, args);
Index: src/main/java/org/modeshape/rhq/plugin/SequencerDiscoveryComponent.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/SequencerDiscoveryComponent.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/SequencerDiscoveryComponent.java	(working copy)
@@ -31,10 +31,12 @@
 import org.apache.commons.logging.LogFactory;
 import org.jboss.managed.api.ComponentType;
 import org.jboss.managed.api.ManagedComponent;
+import org.jboss.metatype.api.types.EnumMetaType;
 import org.jboss.metatype.api.values.CollectionValueSupport;
 import org.jboss.metatype.api.values.CompositeValueSupport;
+import org.jboss.metatype.api.values.EnumValueSupport;
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.modeshape.jboss.managed.ManagedEngine;
 import org.modeshape.jboss.managed.ManagedSequencerConfig;
 import org.modeshape.rhq.plugin.util.ModeShapeManagementView;
@@ -91,12 +93,13 @@
 			return discoveredResources;
 		}
 
-		Collection<ManagedSequencerConfig> sequencerCollection = ModeShapeManagementView
+		Collection<MetaValue> sequencerCollection = ModeShapeManagementView
 				.getSequencerCollectionValue(sequencers);
 
-		for (ManagedSequencerConfig managedSequencer : sequencerCollection) {
+		for (MetaValue managedSequencer : sequencerCollection) {
 
-			String name = managedSequencer.getName();
+			MetaValue name = ((CompositeValueSupport)managedSequencer).get("name");
+			MetaValue description = ((CompositeValueSupport)managedSequencer).get("description");
 
 			/**
 			 * 
@@ -105,10 +108,10 @@
 			 */
 			DiscoveredResourceDetails detail = new DiscoveredResourceDetails(
 					discoveryContext.getResourceType(), // ResourceType
-					name, // Resource Key
-					name, // Resource name
+					ProfileServiceUtil.stringValue(name), // Resource Key
+					ProfileServiceUtil.stringValue(name), // Resource name
 					null, // version
-					managedSequencer.getDescription(), // Description
+					ProfileServiceUtil.stringValue(description), // Description
 					discoveryContext.getDefaultPluginConfiguration(), // Plugin config
 					null // Process info from a process scan
 			);
@@ -117,10 +120,11 @@
 
 			operation = "getProperties";
 
+			EnumValueSupport enumVs = new EnumValueSupport(new EnumMetaType(ManagedEngine.Component.values()), ManagedEngine.Component.SEQUENCER);
+			
 			MetaValue[] args = new MetaValue[] {
-					MetaValueFactory.getInstance().create(name),
-					MetaValueFactory.getInstance().create(
-							ManagedEngine.Component.SEQUENCER) };
+					name,
+					enumVs };
 			
 			MetaValue properties = ModeShapeManagementView
 					.executeManagedOperation(mc, operation, args);
Index: src/main/java/org/modeshape/rhq/plugin/util/ModeShapeManagementView.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/util/ModeShapeManagementView.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/util/ModeShapeManagementView.java	(working copy)
@@ -15,7 +15,7 @@
 import org.jboss.metatype.api.types.MetaType;
 import org.jboss.metatype.api.values.CollectionValueSupport;
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.modeshape.jboss.managed.ManagedRepository;
 import org.modeshape.jboss.managed.ManagedSequencerConfig;
 import org.modeshape.rhq.plugin.objects.ExecutedResult;
@@ -29,9 +29,6 @@
 	private static final Log LOG = LogFactory
 			.getLog(PluginConstants.DEFAULT_LOGGER_CATEGORY);
 
-	private static final MetaValueFactory metaValueFactory = MetaValueFactory
-			.getInstance();
-
 	public ModeShapeManagementView() {
 
 	}
@@ -90,10 +87,7 @@
 				value = executeManagedOperation(
 						ProfileServiceUtil.getManagedEngine(connection),
 						metric,
-						new MetaValue[] { MetaValueFactory
-								.getInstance()
-								.create(
-										valueMap
+						new MetaValue[] { SimpleValueSupport.wrap((String)valueMap
 												.get(ComponentType.Repository.Operations.Parameters.REPOSITORY_NAME)) });
 				resultObject = ProfileServiceUtil.stringValue(value);
 		}
@@ -111,20 +105,14 @@
 			value = executeManagedOperation(
 					ProfileServiceUtil.getManagedEngine(connection),
 					metric,
-					new MetaValue[] { MetaValueFactory
-							.getInstance()
-							.create(
-									valueMap
+					new MetaValue[] { SimpleValueSupport.wrap((String)valueMap
 											.get(ComponentType.Connector.Operations.Parameters.CONNECTOR_NAME)) });
 			resultObject = ProfileServiceUtil.stringValue(value);
 		} else if (metric.equals(ComponentType.Repository.Metrics.ACTIVESESSIONS)) {
 				value = executeManagedOperation(
 						ProfileServiceUtil.getManagedEngine(connection),
 						metric,
-						new MetaValue[] { MetaValueFactory
-								.getInstance()
-								.create(
-										valueMap
+						new MetaValue[] { SimpleValueSupport.wrap((String)valueMap
 												.get(ComponentType.Connector.Operations.Parameters.CONNECTOR_NAME)) });
 				resultObject = ProfileServiceUtil.stringValue(value);
 		}
@@ -175,8 +163,7 @@
 			try {
 				String connectorName = (String) valueMap
 						.get(Connector.Operations.Parameters.CONNECTOR_NAME);
-				MetaValue[] args = new MetaValue[] { metaValueFactory
-						.create(connectorName) };
+				MetaValue[] args = new MetaValue[] { SimpleValueSupport.wrap(connectorName) };
 				MetaValue value = executeManagedOperation(ProfileServiceUtil
 						.getManagedEngine(connection), operationName,
 						operationResult, args);
@@ -267,16 +254,15 @@
 
 	}
 
-	public static Collection<ManagedRepository> getRepositoryCollectionValue(
+	public static Collection<MetaValue> getRepositoryCollectionValue(
 			MetaValue pValue) {
-		Collection<ManagedRepository> list = new ArrayList<ManagedRepository>();
+		Collection<MetaValue> list = new ArrayList<MetaValue>();
 		MetaType metaType = pValue.getMetaType();
 		if (metaType.isCollection()) {
 			for (MetaValue value : ((CollectionValueSupport) pValue)
 					.getElements()) {
 				if (value.getMetaType().isComposite()) {
-					ManagedRepository repository = (ManagedRepository) MetaValueFactory
-							.getInstance().unwrap(value);
+					MetaValue repository = (MetaValue) value;
 					list.add(repository);
 				} else {
 					throw new IllegalStateException(pValue
@@ -301,16 +287,15 @@
 		return sb.toString();
 	}
 
-	public static Collection<ManagedSequencerConfig> getSequencerCollectionValue(
+	public static Collection<MetaValue> getSequencerCollectionValue(
 			MetaValue pValue) {
-		Collection<ManagedSequencerConfig> list = new ArrayList<ManagedSequencerConfig>();
+		Collection<MetaValue> list = new ArrayList<MetaValue>();
 		MetaType metaType = pValue.getMetaType();
 		if (metaType.isCollection()) {
 			for (MetaValue value : ((CollectionValueSupport) pValue)
 					.getElements()) {
 				if (value.getMetaType().isComposite()) {
-					ManagedSequencerConfig sequencer = (ManagedSequencerConfig) MetaValueFactory
-							.getInstance().unwrap(value);
+					MetaValue sequencer = value;
 					list.add(sequencer);
 				} else {
 					throw new IllegalStateException(pValue
Index: src/main/java/org/modeshape/rhq/plugin/ConnectorComponent.java
===================================================================
--- src/main/java/org/modeshape/rhq/plugin/ConnectorComponent.java	(revision 2553)
+++ src/main/java/org/modeshape/rhq/plugin/ConnectorComponent.java	(working copy)
@@ -30,7 +30,7 @@
 import javax.naming.NamingException;
 
 import org.jboss.metatype.api.values.MetaValue;
-import org.jboss.metatype.api.values.MetaValueFactory;
+import org.jboss.metatype.api.values.SimpleValueSupport;
 import org.mc4j.ems.connection.EmsConnection;
 import org.modeshape.rhq.plugin.util.ModeShapeManagementView;
 import org.modeshape.rhq.plugin.util.PluginConstants;
@@ -69,8 +69,7 @@
 		Boolean pingResultSuccess = new Boolean(false);
 		try {
 			String connectorName = this.resourceContext.getResourceKey();
-			MetaValue[] args = new MetaValue[] { MetaValueFactory.getInstance()
-					.create(connectorName) };
+			MetaValue[] args = new MetaValue[] { SimpleValueSupport.wrap(connectorName) };
 			value = ModeShapeManagementView.executeManagedOperation(
 					ProfileServiceUtil.getManagedEngine(getConnection()),
 					"pingConnector", args);
Index: src/main/resources/META-INF/rhq-plugin.xml
===================================================================
--- src/main/resources/META-INF/rhq-plugin.xml	(revision 2553)
+++ src/main/resources/META-INF/rhq-plugin.xml	(working copy)
@@ -132,7 +132,7 @@
 							readOnly="true" />
 						<c:simple-property name="description"
 							displayName="Description" description="The description of this property"
-							required="false" readOnly="true" />
+							required="false" readOnly="true"/>
 					</c:map-property>
 				</c:list-property>
 				<c:list-property name="connectionpoolPropertyList"