Index: ejb3/src/main/java/org/jboss/ejb3/deployers/JBossASKernel.java
===================================================================
--- ejb3/src/main/java/org/jboss/ejb3/deployers/JBossASKernel.java	(revision 109431)
+++ ejb3/src/main/java/org/jboss/ejb3/deployers/JBossASKernel.java	(working copy)
@@ -21,17 +21,6 @@
  */
 package org.jboss.ejb3.deployers;
 
-import java.lang.reflect.Field;
-import java.lang.reflect.Method;
-import java.util.ArrayList;
-import java.util.HashSet;
-import java.util.Set;
-
-import javax.management.MBeanInfo;
-import javax.management.MBeanOperationInfo;
-import javax.management.MBeanServer;
-import javax.management.ObjectName;
-
 import org.jboss.as.ejb3.naming.NamingComponentEjbEncFactory;
 import org.jboss.beans.metadata.plugins.AbstractBeanMetaData;
 import org.jboss.beans.metadata.plugins.AbstractConstructorMetaData;
@@ -48,9 +37,13 @@
 import org.jboss.ejb3.EJBContainer;
 import org.jboss.ejb3.KernelAbstraction;
 import org.jboss.ejb3.MCDependencyPolicy;
+import org.jboss.ejb3.heks.businessobject.EJB31StatefulBusinessObjectFactory;
+import org.jboss.ejb3.heks.businessobject.EJB31StatelessBusinessObjectFactory;
 import org.jboss.ejb3.instantiator.spi.BeanInstantiatorRegistration;
 import org.jboss.ejb3.javaee.JavaEEApplication;
 import org.jboss.ejb3.javaee.JavaEEModule;
+import org.jboss.ejb3.stateful.StatefulContainer;
+import org.jboss.ejb3.stateless.StatelessContainer;
 import org.jboss.kernel.Kernel;
 import org.jboss.kernel.plugins.deployment.AbstractKernelDeployment;
 import org.jboss.kernel.spi.deployment.KernelDeployment;
@@ -58,6 +51,16 @@
 import org.jboss.logging.Logger;
 import org.jboss.reloaded.naming.spi.JavaEEComponent;
 
+import javax.management.MBeanInfo;
+import javax.management.MBeanOperationInfo;
+import javax.management.MBeanServer;
+import javax.management.ObjectName;
+import java.lang.reflect.Field;
+import java.lang.reflect.Method;
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Set;
+
 /**
  * The JBossAS implementation of the ejb3 KernelAbstraction integration api
  * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
@@ -172,6 +175,13 @@
          String beanInstantiatorMcName = BeanInstantiatorRegistration.getInstantiatorRegistrationName(appName, moduleName, container.getEjbName());
          builder.addPropertyMetaData("beanInstantiator", new AbstractInjectionValueMetaData(beanInstantiatorMcName));
 
+         // ahem
+         if(service instanceof StatelessContainer)
+         {
+            ((StatelessContainer) service).setBusinessObjectFactory(new EJB31StatelessBusinessObjectFactory());
+         }
+         if(service instanceof StatefulContainer)
+            ((StatefulContainer) service).setBusinessObjectFactory(new EJB31StatefulBusinessObjectFactory(kernel));
       }
 
       if(unit != null)
Index: component-matrix/pom.xml
===================================================================
--- component-matrix/pom.xml	(revision 109431)
+++ component-matrix/pom.xml	(working copy)
@@ -85,7 +85,7 @@
     <version.org.jboss.cluster.cache.ispn>1.0.0.CR8</version.org.jboss.cluster.cache.ispn>
     <version.org.jboss.common.core>2.2.17.GA</version.org.jboss.common.core>
     <version.org.jboss.deployers>2.2.0.Alpha8</version.org.jboss.deployers>
-    <version.org.jboss.ejb3.depchain>1.0.0-alpha-22</version.org.jboss.ejb3.depchain>
+    <version.org.jboss.ejb3.depchain>1.0.0-alpha-23-SNAPSHOT</version.org.jboss.ejb3.depchain>
     <!-- This to move into the EJB3 BOM -->
     <version.org.jboss.ejb3.embedded>1.0.0-alpha-1</version.org.jboss.ejb3.embedded>
     <version.org.jboss.ejb.api>1.0-alpha-1</version.org.jboss.ejb.api>
Index: build/build.xml
===================================================================
--- build/build.xml	(revision 109431)
+++ build/build.xml	(working copy)
@@ -2056,6 +2056,7 @@
       <fileset refid="org.jboss.ejb3.container:jboss-ejb3-container-spi:jar"/>
       <fileset refid="org.jboss.ejb3.context:jboss-ejb3-context-base:jar"/>
       <fileset refid="org.jboss.ejb3.context:jboss-ejb3-context-naming:jar"/>
+      <fileset refid="org.jboss.ejb3.context:jboss-ejb3-context-spi:jar"/>
       <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-api:jar"/>
       <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-common:jar"/>
       <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-int2:jar"/>
@@ -2067,6 +2068,7 @@
       <fileset refid="org.jboss.ejb3.embedded:jboss-ejb3-embedded-impl-base:jar"/>
       <fileset refid="org.jboss.ejb3.embedded:jboss-ejb3-embedded-impl-shrinkwrap:jar"/>
       <fileset refid="org.jboss.ejb3.embedded:jboss-ejb3-embedded-spi:jar"/>
+      <fileset refid="org.jboss.ejb3.heks:jboss-ejb3-heks:jar"/>
       <fileset refid="org.jboss.ejb3:jboss-ejb3-core:jar"/>
       <fileset refid="org.jboss.ejb3:jboss-ejb3-deployers:jar"/>
       <fileset refid="org.jboss.ejb3:jboss-ejb3-endpoint:jar"/>