Index: plugin_ja.properties
===================================================================
--- plugin_ja.properties	(revision 28821)
+++ plugin_ja.properties	(working copy)
@@ -6,3 +6,4 @@
 occurrenceStructureProvidersExtensionPoint=\u30AA\u30AB\u30EC\u30F3\u30B9\u69CB\u9020\u30D7\u30ED\u30D0\u30A4\u30C0\u30FC
 defaultOccurrenceStructureProviderName=\u30C7\u30D5\u30A9\u30EB\u30C8\u30FB\u30AA\u30AB\u30EC\u30F3\u30B9\u30FB\u30D7\u30ED\u30D0\u30A4\u30C0\u30FC
 Bundle-Name.0=JSP \u30A8\u30C7\u30A3\u30BF\u30FC\u30FB\u30D7\u30E9\u30B0\u30A4\u30F3
+ContentType_JBossToolsINC=JBoss Tools JSP Include
\ No newline at end of file
Index: src/org/jboss/tools/jst/jsp/jspeditor/JSPIncludeContentDescriber.java
===================================================================
--- src/org/jboss/tools/jst/jsp/jspeditor/JSPIncludeContentDescriber.java	(revision 0)
+++ src/org/jboss/tools/jst/jsp/jspeditor/JSPIncludeContentDescriber.java	(revision 0)
@@ -0,0 +1,89 @@
+/******************************************************************************* 
+ * Copyright (c) 2011 Red Hat, Inc. 
+ * Distributed under license by Red Hat, Inc. All rights reserved. 
+ * This program is made available under the terms of the 
+ * Eclipse Public License v1.0 which accompanies this distribution, 
+ * and is available at http://www.eclipse.org/legal/epl-v10.html 
+ * 
+ * Contributors: 
+ * Red Hat, Inc. - initial API and implementation 
+ ******************************************************************************/ 
+package org.jboss.tools.jst.jsp.jspeditor;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.io.Reader;
+
+import org.eclipse.core.internal.content.TextContentDescriber;
+import org.eclipse.core.runtime.content.IContentDescription;
+import org.eclipse.core.runtime.content.ITextContentDescriber;
+
+/**
+ * Content decriber class that helps Eclipse to detect if the *.inc file has jsp content inside.
+ * 
+ * @author Victor Rubezhny
+ *
+ */
+@SuppressWarnings("restriction")
+public class JSPIncludeContentDescriber extends TextContentDescriber implements ITextContentDescriber {
+
+	public int describe(InputStream input, IContentDescription description) throws IOException {
+		InputStreamReader reader = new InputStreamReader(input);
+		try {
+			return (containsJspElements(reader) ? 
+					VALID :
+					INVALID);
+		} finally {
+			reader.close();
+		}
+	}
+
+	public int describe(Reader contents, IContentDescription description) throws IOException {
+		return (containsJspElements(contents) ? 
+			VALID :
+			INVALID);
+	}
+	
+	private boolean containsJspElements(Reader contents) {
+		try {
+			int c = contents.read();
+			while (c != -1) {
+				if (c == '<') { // JSP Code/Tag/Directive Opener check
+					if ((c = contents.read()) == -1)
+						return false;
+					if (c == '%') { // JSP Code/Directive opened
+						return true;
+					}
+					if (c == 'j') { // JSP Tag opener check
+						if ((c = contents.read()) == -1)
+							return false;
+						if (c != 's') 
+							continue;
+						if ((c = contents.read()) == -1)
+							return false;
+						if (c != 'p') 
+							continue;
+						if ((c = contents.read()) == -1)
+							return false;
+						if (c != ':') 
+							continue;
+						
+						// Find the tag close
+						while ((c = contents.read()) != -1) {
+							if (c == '>') {
+								return true;
+							}
+						}
+						continue;
+					}
+				}
+				c = contents.read();
+			}
+		} catch (IOException ex) {
+			ex.printStackTrace();
+			// Ignore 
+		}
+		return false;
+	}
+}
Index: plugin.xml
===================================================================
--- plugin.xml	(revision 28821)
+++ plugin.xml	(working copy)
@@ -194,7 +194,7 @@
             contributorClass="org.jboss.tools.jst.jsp.jspeditor.JSPMultiPageContributor"
             id="org.jboss.tools.jst.jsp.jspeditor.JSPTextEditor"
             matchingStrategy = "org.jboss.tools.common.core.resources.MatchingStrategyImpl"
-            extensions="jsp, jspf, jspx, tag, tagf, inc">
+            extensions="jsp, jspf, jspx, tag, tagf">
          <contentTypeBinding contentTypeId="org.eclipse.jst.jsp.core.jspsource"/>
       </editor>
       <editor 
@@ -538,9 +538,9 @@
 	</extension>
 	
     <extension point="org.eclipse.core.runtime.contentTypes">
-       <file-association
+       <!--file-association
              content-type="org.eclipse.jst.jsp.core.jspsource"
-             file-extensions="inc"/>
+             file-extensions="inc"/ -->
        <file-association
              content-type="org.eclipse.wst.html.core.htmlsource"
              file-extensions="jsf"/>
@@ -972,6 +972,17 @@
       
     </extension>
    
+   <extension point="org.eclipse.core.contenttype.contentTypes"> 
+      <content-type id="org.eclipse.jst.jsp.core.jspsource" 
+       name="%ContentType_JBossToolsINC"
+       base-type="org.eclipse.core.runtime.text"
+       describer="org.jboss.tools.jst.jsp.jspeditor.JSPIncludeContentDescriber"
+       file-extensions="inc"
+       priority="normal" 
+       />
+   </extension>
+   
+   
    <extension
          point="org.jboss.tools.common.model.resourceMapping">
       <mapping
Index: plugin.properties
===================================================================
--- plugin.properties	(revision 28821)
+++ plugin.properties	(working copy)
@@ -21,3 +21,4 @@
 
 vpe.toolbar.name=VPE Toolbar
 
+ContentType_JBossToolsINC=JBoss Tools JSP Include
\ No newline at end of file