Index: intro4/introContent.xml
===================================================================
--- intro4/introContent.xml	(revision 7213)
+++ intro4/introContent.xml	(working copy)
@@ -117,18 +117,26 @@
            		<link url="http://www.jboss.com" label="Welcome to JBoss Developer Studio" />
 			</group>
 			<group id="navigation">
+				<group id="gs-nav-link">
            		<link label="$introTitle-overview$" 
 						url="http://org.eclipse.ui.intro/showPage?id=gettingstarted" id="gettingstarted">
    				</link>
+   				</group>>
+				<group id="cn-nav-link">
 				<link label="$introTitle-createnew$" 
 						url="http://org.eclipse.ui.intro/showPage?id=createnew" id="createnew">
    				</link>
+   				</group>
+   				<group id="ap-nav-link">
 				<link label="$introTitle-perspectives$" 
 						url="http://org.eclipse.ui.intro/showPage?id=perspectives" id="perspectives">
    				</link>
+   				</group>
+   				<group id="wr-nav-link">
 				<link label="$introTitle-webresources$" 
 						url="http://org.eclipse.ui.intro/showPage?id=webresources" id="webresources">
    				</link>
+   				</group>
 			</group>
 		    <group id="workbench">
 	   			<link url="http://org.eclipse.ui.intro/switchToLaunchBar" label="Workbench" />
@@ -204,18 +212,26 @@
            		<link url="http://www.jboss.com/products/devstudio" label="Welcome to JBoss Developer Studio" />
 			</group>
 			<group id="navigation">
+				<group id="gs-nav-link">
            		<link label="$introTitle-overview$" 
 						url="http://org.eclipse.ui.intro/showPage?id=gettingstarted" id="gettingstarted">
    				</link>
+   				</group>>
+				<group id="cn-nav-link">
 				<link label="$introTitle-createnew$" 
 						url="http://org.eclipse.ui.intro/showPage?id=createnew" id="createnew">
    				</link>
+   				</group>
+   				<group id="ap-nav-link">
 				<link label="$introTitle-perspectives$" 
 						url="http://org.eclipse.ui.intro/showPage?id=perspectives" id="perspectives">
    				</link>
+   				</group>
+   				<group id="wr-nav-link">
 				<link label="$introTitle-webresources$" 
 						url="http://org.eclipse.ui.intro/showPage?id=webresources" id="webresources">
    				</link>
+   				</group>
 			</group>
 	        <group id="workbench">
 	   			<link url="http://org.eclipse.ui.intro/switchToLaunchBar" label="Workbench" />
@@ -292,18 +308,26 @@
            		<link url="http://www.jboss.com" label="Welcome to JBoss Developer Studio" />
 			</group>
 			<group id="navigation">
+				<group id="gs-nav-link">
            		<link label="$introTitle-overview$" 
 						url="http://org.eclipse.ui.intro/showPage?id=gettingstarted" id="gettingstarted">
    				</link>
+   				</group>>
+				<group id="cn-nav-link">
 				<link label="$introTitle-createnew$" 
 						url="http://org.eclipse.ui.intro/showPage?id=createnew" id="createnew">
    				</link>
+   				</group>
+   				<group id="ap-nav-link">
 				<link label="$introTitle-perspectives$" 
 						url="http://org.eclipse.ui.intro/showPage?id=perspectives" id="perspectives">
    				</link>
+   				</group>
+   				<group id="wr-nav-link">
 				<link label="$introTitle-webresources$" 
 						url="http://org.eclipse.ui.intro/showPage?id=webresources" id="webresources">
    				</link>
+   				</group>
 			</group>
 	        <group id="workbench">
 	   			<link url="http://org.eclipse.ui.intro/switchToLaunchBar" label="Workbench" />
@@ -410,18 +434,26 @@
            		<link url="http://www.jboss.com" label="Welcome to JBoss Developer Studio" />
 			</group>
 			<group id="navigation">
+				<group id="gs-nav-link">
            		<link label="$introTitle-overview$" 
 						url="http://org.eclipse.ui.intro/showPage?id=gettingstarted" id="gettingstarted">
    				</link>
+   				</group>>
+				<group id="cn-nav-link">
 				<link label="$introTitle-createnew$" 
 						url="http://org.eclipse.ui.intro/showPage?id=createnew" id="createnew">
    				</link>
+   				</group>
+   				<group id="ap-nav-link">
 				<link label="$introTitle-perspectives$" 
 						url="http://org.eclipse.ui.intro/showPage?id=perspectives" id="perspectives">
    				</link>
+   				</group>
+   				<group id="wr-nav-link">
 				<link label="$introTitle-webresources$" 
 						url="http://org.eclipse.ui.intro/showPage?id=webresources" id="webresources">
    				</link>
+   				</group>
 			</group>
 	        <group id="workbench">
 	   			<link url="http://org.eclipse.ui.intro/switchToLaunchBar" label="Workbench" />
Index: themes/jbds/html/internal-page.css
===================================================================
--- themes/jbds/html/internal-page.css	(revision 7213)
+++ themes/jbds/html/internal-page.css	(working copy)
@@ -37,7 +37,7 @@
 
 #welcome a .link-label {
 	color:red;
-	margin-left:-9999px;	
+	margin-left:-9999px;
 }
 
 #welcome a .link-extra-div {
@@ -48,14 +48,8 @@
 	position:absolute;
 	top:0;
 	right:20px;	
-	width:63px;
-}
-
-#navigation {
-	position:absolute;
-	top:5;
-	right:60px;	
-	width:180px;
+	width:100px;
+	height: 100px;
 }
 
 #workbench a img {
@@ -66,13 +60,110 @@
 	width:43px;
 }
 
-
 #workbench a span.link-label, #workbench a .link-label, #workbench a:active .link-label, #workbench a:hover .link-label, #workbench a:focus .link-label {
-	display:none;
+/*	display:none; */
+}
+
+#workbench a .link-label {
+	position : relative;
+	color: #000000;
+	visibility : hidden;
+	font-weight: bold;
+	font-family:Arial, Helvetica, sans-serif;
+	font-size:10px;
+	top: -13px;
+	left: 25px;
+	margin-top: 0px;
+	text-align:center;
+	width: 100px;
+}
+
+#workbench a:hover .link-label  {
+	position : relative;
+	color:#FFFFFF;	
+	visibility : visible;
+    text-decoration : none;
+	font-weight: bold;
+	font-family:Arial, Helvetica, sans-serif;
+	font-size:10px;
+	top: -13px;
+	left: 25px;
+	margin-top: 0px;
+	text-align:center;
+	width: 100px;
+}
+
+#navigation {
+	position:absolute;
+	top:5;
+	right:60px;	
+	width:100px;
+	height: 100px;
+}
+
+#navigation a img {
+	display:block;
+	left:5px;
+	height:32px;
+	width:32px;
 }
 
 #navigation a span.link-label, #navigation a .link-label, #navigation a:active .link-label, #navigation a:hover .link-label, #navigation a:focus .link-label {
-	display:none;
+/*	display:none; */
+}
+
+#gs-nav-link {
+	position:absolute;
+	top:0;
+	right: 135px;
+	width: 100px;
+}
+#cn-nav-link {
+	position:absolute;
+	top:0;
+	right: 90px;
+	width: 100px;
+}
+#ap-nav-link {
+	position:absolute;
+	top:0;
+	right: 45px;
+	width: 100px;
+}
+#wr-nav-link {
+	position:absolute;
+	top:0;
+	right: 0px;
+	width: 100px;
+}
+
+#navigation a .link-label {
+	position : relative;
+	color: #000000;
+	visibility : hidden;
+	font-weight: bold;
+	font-family:Arial, Helvetica, sans-serif;
+	font-size:10px;
+	top: 10px;
+	left : -15px;
+	margin-top: 0px;
+	text-align:center;
+	width: 100px;
+}
+
+#navigation a:hover .link-label  {
+	position : relative;
+	color:#FFFFFF;	
+	visibility : visible;
+    text-decoration : none;
+	font-weight: bold;
+	font-family:Arial, Helvetica, sans-serif;
+	font-size:10px;
+	top: 10px;
+	left : -15px;
+	margin-top: 0px;
+	text-align:center;
+	width: 100px;
 }
 
 #welcome a .link-extra-div, #navigation a .link-extra-div {